pcr_relay_get_key_internal() {
    "$HERE"/pcr_relay_get_key.lua &
    PID=$!
    TIME_LEFT="${1:-10}"
    while [ "$TIME_LEFT" -gt 0 ] && [ -d /proc/$PID ]; do
        sleep 1
        TIME_LEFT="$(($TIME_LEFT-1))"
    done
    kill $PID
    if [ "${TIME_LEFT}" -eq 0 ]; then
        echo timeout
    fi
}

pcr_relay_get_key() {
    pcr_relay_bridged_scope pcr_relay_get_key_internal
}

pcr_confirm () {
    if [ -z "$PCR_SKIP_CONFIRM" ]; then
        while true; do
            pcr_message "$1" 'ON=YES OFF=NO'
            KEY=`pcr_relay_get_key`
            case "$KEY" in
                on)
                    return 0
                    ;;
                off)
                    return 1
                    ;;
                timeout)
                    pcr_message "$1" "TIMEOUT, SKIPPED"
                    sleep 1
                    return 1
                    ;;
                *)
                    pcr_message "WEIRD KEY $KEY" 'ON=YES OFF=NO'
                    sleep 1
                    ;;
            esac
        done
    else
        return 0
    fi
}
