pcr_update_atheros_bootloader () {
    if [ "$PCR_PRESERVE_OVERLAY" != "0" ]; then
        pcr_relay_send '$L10000'
        cp "$1" /uboot.bin
        cat /etc/fw_env.config > /lib/__sysupgrade_fw_env
        cat > /etc/uci-defaults/000-install-uboot <<EOF
#!/bin/sh
set -x
echo -n -e '$L1\r\n' >/dev/${PCR_RELAY_PORT}
mtd write /uboot.bin __bootloader
fw_setenv bootargs "`fw_printenv -n bootargs |sed 's/,128k@0(__bootloader)//g'`"
rm /etc/uci-defaults/000-install-uboot
rm /uboot.bin
sync
echo -n -e '$L0\r\n' >/dev/${PCR_RELAY_PORT}
reboot
EOF
        chmod +x /etc/uci-defaults/000-install-uboot
        pcr_relay_send '$L10'
        fw_setenv bootargs "`fw_printenv -n bootargs |sed 's/mtdparts=[^ ]*/&,128k@0(__bootloader)/g'`"
        sync
        PCR_PRESERVE_OVERLAY="1"
        PCR_REQUIRE_REBOOT_ON_SHUTDOWN=1
        pcr_success_message 'Atheros bootloader update configured' 'WILL UPDATE' 'BOOTLOADER'
    else
        pcr_failure_message 'Atheros bootloader update postponed due to conflict' 'BOOTLOADER' 'UPDATE POSTPONED'
    fi
}
