pcr_update_avr_firmware_internal () {
    pcr_info_message 'AVR update initializing' 'AVR UPDATE' 'INITIALIZING'

    pcr_install_utility_packages # PACKAGE_DEPEND avr_firmware flash_avr_firmware tcsync avrdude libncurses libreadline libftdi libusb libusb-compat libelf

    pcr_info_message 'AVR update in progress' 'AVR UPDATING' 'PLEASE WAIT'

    OK=0
    for F in $1/*; do
        if [ -f "$F" ] && PCR_RELAY_PORT=$PCR_RELAY_PORT PCR_RELAY_BAUD_RATE=$PCR_RELAY_BAUD_RATE flash_avr_firmware `basename "$F"` "$F"; then
            OK=1
            break
        fi
    done
    if [ -n "$PCR_UPDATE_AVR_NEED_UNCONDITIONAL_RESET" ]; then
        # NB: fragment copied from recent flash_avr_firmware: it's not
        # guaranteed to be present in the packaged version.
        echo 23 > /sys/class/gpio/export
        echo out >/sys/class/gpio/gpio23/direction
        echo 0 >/sys/class/gpio/gpio23/value
        sleep 1
        echo 1 >/sys/class/gpio/gpio23/value
        echo 23 >/sys/class/gpio/unexport
    fi
    pcr_reset_ui
    if [ "$OK" = 1 ]; then
        pcr_success_message 'AVR updated' "AVR" "UPDATED"
    else
        pcr_failure_message 'AVR update failed' "AVR UPDATE" "FAILED"
    fi
}

pcr_update_avr_firmware () {
    if [ -z "$2" ] || [ "$2" != "`pcr_relay_get_version`" ]; then
        pcr_relay_unbridged_scope pcr_update_avr_firmware_internal "$1"
    else
        pcr_success_message 'AVR already up-to-date' "AVR ALREADY" "UP TO DATE"
    fi
}
